
#import "b4i_b4xpagesmanager.h"
#import "b4i_main.h"
#import "b4i_b4xmainpage.h"
#import "b4i_b4xpages.h"
#import "b4i_b4xbitset.h"
#import "b4i_b4xbytesbuilder.h"
#import "b4i_b4xcollections.h"
#import "b4i_b4xorderedmap.h"
#import "b4i_b4xset.h"
#import "b4i_b4xpagesdelegator.h"

@implementation _b4xpageparent
-(void)Initialize{
self.IsInitialized = true;
self->_NativeType = [B4IPage new];
}
- (NSString*)description {
return [B4I TypeToString:self :false];}
@end
@implementation _b4xpageinfo
-(void)Initialize{
self.IsInitialized = true;
self->_B4XPage = [NSObject new];
self->_Id = @"";
self->_Created = false;
self->_Title = [NSObject new];
self->_Root = [B4XViewWrapper new];
self->_IsFirst = false;
self->_Parent = [_b4xpageparent new];
}
- (NSString*)description {
return [B4I TypeToString:self :false];}
@end

@implementation b4i_b4xpagesmanager 


+ (B4I*)createBI {
    return [B4IShellBI alloc];
}

- (void)dealloc {
    if (self.bi != nil)
        NSLog(@"Class (b4i_b4xpagesmanager) instance released.");
}

- (NSString*)  _initialize:(b4i_b4xpagesmanager*) __ref :(B4I*) _ba :(B4INavigationControllerWrapper*) _navcontrol{
__ref = self;
[self initializeClassModule];
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"initialize"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"initialize::" :@[[B4I nilToNSNull:_ba],[B4I nilToNSNull:_navcontrol]]]);}
BOOL _nonmainpagewasadded = false;
B4IRDebugUtils.currentLine=5046272;
 //BA.debugLineNum = 5046272;BA.debugLine="Public Sub Initialize (NavControl As NavigationCon";
B4IRDebugUtils.currentLine=5046274;
 //BA.debugLineNum = 5046274;BA.debugLine="IdToB4XPage.Initialize";
[__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _initialize /*NSString**/ :nil :self.bi];
B4IRDebugUtils.currentLine=5046275;
 //BA.debugLineNum = 5046275;BA.debugLine="RootB4XToPage.Initialize";
[__ref->__rootb4xtopage /*b4i_b4xorderedmap**/  _initialize /*NSString**/ :nil :self.bi];
B4IRDebugUtils.currentLine=5046276;
 //BA.debugLineNum = 5046276;BA.debugLine="mStackOfPageIds.Initialize";
[__ref->__mstackofpageids /*b4i_b4xset**/  _initialize /*NSString**/ :nil :self.bi];
B4IRDebugUtils.currentLine=5046287;
 //BA.debugLineNum = 5046287;BA.debugLine="mMainForm = NavControl";
__ref->__mmainform /*B4INavigationControllerWrapper**/  = _navcontrol;
B4IRDebugUtils.currentLine=5046289;
 //BA.debugLineNum = 5046289;BA.debugLine="B4XPages.InternalSetPagesManager(Me)";
[self->__b4xpages _internalsetpagesmanager /*NSString**/ :self];
B4IRDebugUtils.currentLine=5046290;
 //BA.debugLineNum = 5046290;BA.debugLine="MainPage.Initialize";
[__ref->__mainpage /*b4i_b4xmainpage**/  _initialize /*NSString**/ :nil :self.bi];
B4IRDebugUtils.currentLine=5046291;
 //BA.debugLineNum = 5046291;BA.debugLine="Dim NonMainPageWasAdded As Boolean = IdToB4XPage.";
_nonmainpagewasadded = [__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _getsize /*int*/ :nil]>0;
B4IRDebugUtils.currentLine=5046292;
 //BA.debugLineNum = 5046292;BA.debugLine="IdToB4XPage.Put(\"~~~~~temp~~~~\", CreateB4XPageInf";
[__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _put /*NSString**/ :nil :(NSObject*)(@"~~~~~temp~~~~") :(NSObject*)([__ref _createb4xpageinfo /*_b4xpageinfo**/ :nil :(NSObject*)(__ref->__mainpage /*b4i_b4xmainpage**/ ) :@"" :false :(NSObject*)(@"")])];
B4IRDebugUtils.currentLine=5046293;
 //BA.debugLineNum = 5046293;BA.debugLine="BackgroundStateChanged(True)";
[__ref _backgroundstatechanged /*NSString**/ :nil :true];
B4IRDebugUtils.currentLine=5046294;
 //BA.debugLineNum = 5046294;BA.debugLine="IdToB4XPage.Remove(\"~~~~~temp~~~~\")";
[__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _remove /*NSString**/ :nil :(NSObject*)(@"~~~~~temp~~~~")];
B4IRDebugUtils.currentLine=5046295;
 //BA.debugLineNum = 5046295;BA.debugLine="AddPageAndCreate(\"MainPage\", MainPage)";
[__ref _addpageandcreate /*NSString**/ :nil :@"MainPage" :(NSObject*)(__ref->__mainpage /*b4i_b4xmainpage**/ )];
B4IRDebugUtils.currentLine=5046296;
 //BA.debugLineNum = 5046296;BA.debugLine="If LogEvents = False Then";
if (__ref->__logevents /*BOOL*/ ==false) { 
B4IRDebugUtils.currentLine=5046297;
 //BA.debugLineNum = 5046297;BA.debugLine="Log(\"Call B4XPages.GetManager.LogEvents = True t";
[self->___c LogImpl:@"95046297" :@"Call B4XPages.GetManager.LogEvents = True to enable logging B4XPages events." :0];
 };
B4IRDebugUtils.currentLine=5046299;
 //BA.debugLineNum = 5046299;BA.debugLine="If NonMainPageWasAdded Then";
if (_nonmainpagewasadded) { 
B4IRDebugUtils.currentLine=5046300;
 //BA.debugLineNum = 5046300;BA.debugLine="If Not(xui.IsB4i) Then";
if ((!([__ref->__xui /*B4IXUI**/  IsB4i]))) { 
B4IRDebugUtils.currentLine=5046301;
 //BA.debugLineNum = 5046301;BA.debugLine="RaiseEvent(GetTopPage, \"B4XPage_Appear\", Null)";
[__ref _raiseevent /*NSString**/ :nil :[__ref _gettoppage /*_b4xpageinfo**/ :nil] :@"B4XPage_Appear" :(B4IArray*)(nil)];
 };
 };
B4IRDebugUtils.currentLine=5046304;
 //BA.debugLineNum = 5046304;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _addpage:(b4i_b4xpagesmanager*) __ref :(NSString*) _id :(NSObject*) _b4xpage{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"addpage"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"addpage::" :@[[B4I nilToNSNull:_id],[B4I nilToNSNull:_b4xpage]]]);}
NSString* _idtolower = @"";
B4IRDebugUtils.currentLine=5111808;
 //BA.debugLineNum = 5111808;BA.debugLine="Public Sub AddPage (Id As String, B4XPage As Objec";
B4IRDebugUtils.currentLine=5111809;
 //BA.debugLineNum = 5111809;BA.debugLine="Dim IdToLower As String = Id.ToLowerCase";
_idtolower = [_id ToLowerCase];
B4IRDebugUtils.currentLine=5111810;
 //BA.debugLineNum = 5111810;BA.debugLine="If IdToB4XPage.ContainsKey(IdToLower) Then";
if ([__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _containskey /*BOOL*/ :nil :(NSObject*)(_idtolower)]) { 
B4IRDebugUtils.currentLine=5111811;
 //BA.debugLineNum = 5111811;BA.debugLine="Log($\"Page with this id already exists: ${IdToLo";
[self->___c LogImpl:@"95111811" :([@[@"Page with this id already exists: ",[self->___c SmartStringFormatter:@"" :(NSObject*)(_idtolower)],@"!"] componentsJoinedByString:@""]) :0];
B4IRDebugUtils.currentLine=5111812;
 //BA.debugLineNum = 5111812;BA.debugLine="Return";
if (true) return @"";
 };
B4IRDebugUtils.currentLine=5111814;
 //BA.debugLineNum = 5111814;BA.debugLine="IdToB4XPage.Put(IdToLower, CreateB4XPageInfo(B4XP";
[__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _put /*NSString**/ :nil :(NSObject*)(_idtolower) :(NSObject*)([__ref _createb4xpageinfo /*_b4xpageinfo**/ :nil :_b4xpage :_idtolower :false :(NSObject*)(_id)])];
B4IRDebugUtils.currentLine=5111815;
 //BA.debugLineNum = 5111815;BA.debugLine="If IdToB4XPage.Size = 1 Then ShowPage(IdToLower)";
if ([__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _getsize /*int*/ :nil]==1) { 
[__ref _showpage /*NSString**/ :nil :_idtolower];};
B4IRDebugUtils.currentLine=5111816;
 //BA.debugLineNum = 5111816;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _addpageandcreate:(b4i_b4xpagesmanager*) __ref :(NSString*) _id :(NSObject*) _b4xpage{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"addpageandcreate"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"addpageandcreate::" :@[[B4I nilToNSNull:_id],[B4I nilToNSNull:_b4xpage]]]);}
B4IRDebugUtils.currentLine=5177344;
 //BA.debugLineNum = 5177344;BA.debugLine="Public Sub AddPageAndCreate (Id As String, B4XPage";
B4IRDebugUtils.currentLine=5177345;
 //BA.debugLineNum = 5177345;BA.debugLine="AddPage (Id, B4XPage)";
[__ref _addpage /*NSString**/ :nil :_id :_b4xpage];
B4IRDebugUtils.currentLine=5177346;
 //BA.debugLineNum = 5177346;BA.debugLine="CreatePageIfNeeded(GetPageFromId(Id))";
[__ref _createpageifneeded /*NSString**/ :nil :[__ref _getpagefromid /*_b4xpageinfo**/ :nil :_id]];
B4IRDebugUtils.currentLine=5177347;
 //BA.debugLineNum = 5177347;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _closepage:(b4i_b4xpagesmanager*) __ref :(NSObject*) _b4xpage{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"closepage"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"closepage:" :@[[B4I nilToNSNull:_b4xpage]]]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5373952;
 //BA.debugLineNum = 5373952;BA.debugLine="Public Sub ClosePage (B4XPage As Object)";
B4IRDebugUtils.currentLine=5373953;
 //BA.debugLineNum = 5373953;BA.debugLine="Dim pi As B4XPageInfo = FindPIFromB4XPage(B4XPage";
_pi = [__ref _findpifromb4xpage /*_b4xpageinfo**/ :nil :_b4xpage];
B4IRDebugUtils.currentLine=5373954;
 //BA.debugLineNum = 5373954;BA.debugLine="If mStackOfPageIds.Contains(pi.Id) = False Then R";
if ([__ref->__mstackofpageids /*b4i_b4xset**/  _contains /*BOOL*/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )]==false) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=5373955;
 //BA.debugLineNum = 5373955;BA.debugLine="If xui.IsB4i And GetTopPage <> pi Then";
if ([__ref->__xui /*B4IXUI**/  IsB4i] && [[__ref _gettoppage /*_b4xpageinfo**/ :nil] isEqual:_pi] == false) { 
B4IRDebugUtils.currentLine=5373956;
 //BA.debugLineNum = 5373956;BA.debugLine="Log(\"Only top page can be closed\")";
[self->___c LogImpl:@"95373956" :@"Only top page can be closed" :0];
B4IRDebugUtils.currentLine=5373957;
 //BA.debugLineNum = 5373957;BA.debugLine="Return";
if (true) return @"";
 }else if([__ref->__xui /*B4IXUI**/  IsB4i] && [__ref->__mstackofpageids /*b4i_b4xset**/  _getsize /*int*/ :nil]==1) { 
B4IRDebugUtils.currentLine=5373959;
 //BA.debugLineNum = 5373959;BA.debugLine="Log(\"First page cannot be closed\")";
[self->___c LogImpl:@"95373959" :@"First page cannot be closed" :0];
B4IRDebugUtils.currentLine=5373960;
 //BA.debugLineNum = 5373960;BA.debugLine="Return";
if (true) return @"";
 };
B4IRDebugUtils.currentLine=5373962;
 //BA.debugLineNum = 5373962;BA.debugLine="ClosePageImpl(pi)";
[__ref _closepageimpl /*NSString**/ :nil :_pi];
B4IRDebugUtils.currentLine=5373963;
 //BA.debugLineNum = 5373963;BA.debugLine="If GetTopPage = pi Then";
if ([[__ref _gettoppage /*_b4xpageinfo**/ :nil] isEqual:_pi]) { 
B4IRDebugUtils.currentLine=5373964;
 //BA.debugLineNum = 5373964;BA.debugLine="TopPageDisappear";
[__ref _toppagedisappear /*NSString**/ :nil];
 };
B4IRDebugUtils.currentLine=5373966;
 //BA.debugLineNum = 5373966;BA.debugLine="If xui.IsB4A And mStackOfPageIds.Size = 1 Then Re";
if ([__ref->__xui /*B4IXUI**/  IsB4A] && [__ref->__mstackofpageids /*b4i_b4xset**/  _getsize /*int*/ :nil]==1) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=5373967;
 //BA.debugLineNum = 5373967;BA.debugLine="mStackOfPageIds.Remove(pi.Id)";
[__ref->__mstackofpageids /*b4i_b4xset**/  _remove /*NSString**/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )];
B4IRDebugUtils.currentLine=5373968;
 //BA.debugLineNum = 5373968;BA.debugLine="If xui.IsB4A Then ShowPageImpl(GetTopPage)";
if ([__ref->__xui /*B4IXUI**/  IsB4A]) { 
[__ref _showpageimpl /*NSString**/ :nil :[__ref _gettoppage /*_b4xpageinfo**/ :nil]];};
B4IRDebugUtils.currentLine=5373969;
 //BA.debugLineNum = 5373969;BA.debugLine="TopPageAppear";
[__ref _toppageappear /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5373970;
 //BA.debugLineNum = 5373970;BA.debugLine="End Sub";
return @"";
}
- (_b4xpageinfo*)  _findpifromb4xpage:(b4i_b4xpagesmanager*) __ref :(NSObject*) _page{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"findpifromb4xpage"])
	 {return ((_b4xpageinfo*) [B4IDebug delegate:self.bi :@"findpifromb4xpage:" :@[[B4I nilToNSNull:_page]]]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5898240;
 //BA.debugLineNum = 5898240;BA.debugLine="Public Sub FindPIFromB4XPage (Page As Object) As B";
B4IRDebugUtils.currentLine=5898241;
 //BA.debugLineNum = 5898241;BA.debugLine="For Each pi As B4XPageInfo In IdToB4XPage.Values";
{
const id<B4IIterable> group1 = [__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _getvalues /*B4IList**/ :nil];
const int groupLen1 = group1.Size
;int index1 = 0;
;
for (; index1 < groupLen1;index1++){
_pi = (_b4xpageinfo*)([group1 Get:index1]);
B4IRDebugUtils.currentLine=5898242;
 //BA.debugLineNum = 5898242;BA.debugLine="If pi.B4XPage = Page Then";
if ([_pi->_B4XPage /*NSObject**/  isEqual:_page]) { 
B4IRDebugUtils.currentLine=5898243;
 //BA.debugLineNum = 5898243;BA.debugLine="Return pi";
if (true) return _pi;
 };
 }
};
B4IRDebugUtils.currentLine=5898246;
 //BA.debugLineNum = 5898246;BA.debugLine="Return Null";
if (true) return (_b4xpageinfo*)(nil);
B4IRDebugUtils.currentLine=5898247;
 //BA.debugLineNum = 5898247;BA.debugLine="End Sub";
return nil;
}
- (NSObject*)  _getpage:(b4i_b4xpagesmanager*) __ref :(NSString*) _id{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"getpage"])
	 {return ((NSObject*) [B4IDebug delegate:self.bi :@"getpage:" :@[[B4I nilToNSNull:_id]]]);}
B4IRDebugUtils.currentLine=6291456;
 //BA.debugLineNum = 6291456;BA.debugLine="Public Sub GetPage (Id As String) As Object";
B4IRDebugUtils.currentLine=6291457;
 //BA.debugLineNum = 6291457;BA.debugLine="Return GetPageFromId(Id).B4XPage";
if (true) return [__ref _getpagefromid /*_b4xpageinfo**/ :nil :_id]->_B4XPage /*NSObject**/ ;
B4IRDebugUtils.currentLine=6291458;
 //BA.debugLineNum = 6291458;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _settitle:(b4i_b4xpagesmanager*) __ref :(NSObject*) _b4xpage :(NSObject*) _title{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"settitle"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"settitle::" :@[[B4I nilToNSNull:_b4xpage],[B4I nilToNSNull:_title]]]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=6160384;
 //BA.debugLineNum = 6160384;BA.debugLine="Public Sub SetTitle (B4XPage As Object, Title As O";
B4IRDebugUtils.currentLine=6160385;
 //BA.debugLineNum = 6160385;BA.debugLine="Dim pi As B4XPageInfo = FindPIFromB4XPage(B4XPage";
_pi = [__ref _findpifromb4xpage /*_b4xpageinfo**/ :nil :_b4xpage];
B4IRDebugUtils.currentLine=6160386;
 //BA.debugLineNum = 6160386;BA.debugLine="pi.Title = Title";
_pi->_Title /*NSObject**/  = _title;
B4IRDebugUtils.currentLine=6160387;
 //BA.debugLineNum = 6160387;BA.debugLine="pi.Parent.NativeType.Title = Title";
[_pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/  setTitle:[self.bi ObjectToString:_title]];
B4IRDebugUtils.currentLine=6160388;
 //BA.debugLineNum = 6160388;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _showpage:(b4i_b4xpagesmanager*) __ref :(NSString*) _id{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"showpage"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"showpage:" :@[[B4I nilToNSNull:_id]]]);}
_b4xpageinfo* _pi = nil;
int _index = 0;
int _i = 0;
B4IRDebugUtils.currentLine=5242880;
 //BA.debugLineNum = 5242880;BA.debugLine="Public Sub ShowPage (Id As String)";
B4IRDebugUtils.currentLine=5242881;
 //BA.debugLineNum = 5242881;BA.debugLine="Dim pi As B4XPageInfo = GetPageFromId(Id)";
_pi = [__ref _getpagefromid /*_b4xpageinfo**/ :nil :_id];
B4IRDebugUtils.currentLine=5242882;
 //BA.debugLineNum = 5242882;BA.debugLine="If pi = GetTopPage Then Return";
if ([_pi isEqual:[__ref _gettoppage /*_b4xpageinfo**/ :nil]]) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=5242883;
 //BA.debugLineNum = 5242883;BA.debugLine="CreatePageIfNeeded(pi)";
[__ref _createpageifneeded /*NSString**/ :nil :_pi];
B4IRDebugUtils.currentLine=5242884;
 //BA.debugLineNum = 5242884;BA.debugLine="TopPageDisappear";
[__ref _toppagedisappear /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5242891;
 //BA.debugLineNum = 5242891;BA.debugLine="If mStackOfPageIds.Contains(pi.Id) Then";
if ([__ref->__mstackofpageids /*b4i_b4xset**/  _contains /*BOOL*/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )]) { 
B4IRDebugUtils.currentLine=5242892;
 //BA.debugLineNum = 5242892;BA.debugLine="Dim index As Int = mStackOfPageIds.AsList.IndexO";
_index = [[__ref->__mstackofpageids /*b4i_b4xset**/  _aslist /*B4IList**/ :nil] IndexOf:(NSObject*)(_pi->_Id /*NSString**/ )];
B4IRDebugUtils.currentLine=5242893;
 //BA.debugLineNum = 5242893;BA.debugLine="For i = mStackOfPageIds.Size - 1 To index + 1 St";
{
const int step7 = -1;
const int limit7 = (int) (_index+1);
_i = (int) ([__ref->__mstackofpageids /*b4i_b4xset**/  _getsize /*int*/ :nil]-1) ;
for (;_i >= limit7 ;_i = _i + step7 ) {
B4IRDebugUtils.currentLine=5242894;
 //BA.debugLineNum = 5242894;BA.debugLine="mStackOfPageIds.Remove(mStackOfPageIds.AsList.G";
[__ref->__mstackofpageids /*b4i_b4xset**/  _remove /*NSString**/ :nil :[[__ref->__mstackofpageids /*b4i_b4xset**/  _aslist /*B4IList**/ :nil] Get:_i]];
 }
};
 };
B4IRDebugUtils.currentLine=5242898;
 //BA.debugLineNum = 5242898;BA.debugLine="mStackOfPageIds.Remove(pi.Id)";
[__ref->__mstackofpageids /*b4i_b4xset**/  _remove /*NSString**/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )];
B4IRDebugUtils.currentLine=5242899;
 //BA.debugLineNum = 5242899;BA.debugLine="ShowPageImpl(pi)";
[__ref _showpageimpl /*NSString**/ :nil :_pi];
B4IRDebugUtils.currentLine=5242900;
 //BA.debugLineNum = 5242900;BA.debugLine="mStackOfPageIds.Add(pi.Id)";
[__ref->__mstackofpageids /*b4i_b4xset**/  _add /*NSString**/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )];
B4IRDebugUtils.currentLine=5242901;
 //BA.debugLineNum = 5242901;BA.debugLine="TopPageAppear";
[__ref _toppageappear /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5242902;
 //BA.debugLineNum = 5242902;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _showpageandremovepreviouspages:(b4i_b4xpagesmanager*) __ref :(NSString*) _id{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"showpageandremovepreviouspages"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"showpageandremovepreviouspages:" :@[[B4I nilToNSNull:_id]]]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5308416;
 //BA.debugLineNum = 5308416;BA.debugLine="Public Sub ShowPageAndRemovePreviousPages (Id As S";
B4IRDebugUtils.currentLine=5308417;
 //BA.debugLineNum = 5308417;BA.debugLine="If GetTopPage = Null Then";
if ([__ref _gettoppage /*_b4xpageinfo**/ :nil]== nil) { 
B4IRDebugUtils.currentLine=5308418;
 //BA.debugLineNum = 5308418;BA.debugLine="ShowPage(Id)";
[__ref _showpage /*NSString**/ :nil :_id];
B4IRDebugUtils.currentLine=5308419;
 //BA.debugLineNum = 5308419;BA.debugLine="Return";
if (true) return @"";
 };
B4IRDebugUtils.currentLine=5308421;
 //BA.debugLineNum = 5308421;BA.debugLine="Dim pi As B4XPageInfo = GetPageFromId(Id)";
_pi = [__ref _getpagefromid /*_b4xpageinfo**/ :nil :_id];
B4IRDebugUtils.currentLine=5308422;
 //BA.debugLineNum = 5308422;BA.debugLine="CreatePageIfNeeded(pi)";
[__ref _createpageifneeded /*NSString**/ :nil :_pi];
B4IRDebugUtils.currentLine=5308423;
 //BA.debugLineNum = 5308423;BA.debugLine="TopPageDisappear";
[__ref _toppagedisappear /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5308425;
 //BA.debugLineNum = 5308425;BA.debugLine="mMainForm.SetPagesStack(Array(pi.Parent.NativeTyp";
[__ref->__mmainform /*B4INavigationControllerWrapper**/  SetPagesStack:[self.bi ArrayToList:[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)((_pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/ ).object)]]]]];
B4IRDebugUtils.currentLine=5308437;
 //BA.debugLineNum = 5308437;BA.debugLine="mStackOfPageIds.Clear";
[__ref->__mstackofpageids /*b4i_b4xset**/  _clear /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5308438;
 //BA.debugLineNum = 5308438;BA.debugLine="mStackOfPageIds.Add(pi.Id)";
[__ref->__mstackofpageids /*b4i_b4xset**/  _add /*NSString**/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )];
B4IRDebugUtils.currentLine=5308439;
 //BA.debugLineNum = 5308439;BA.debugLine="If xui.IsB4A Or xui.IsB4J Then";
if ([__ref->__xui /*B4IXUI**/  IsB4A] || [__ref->__xui /*B4IXUI**/  IsB4J]) { 
B4IRDebugUtils.currentLine=5308440;
 //BA.debugLineNum = 5308440;BA.debugLine="ShowPageImpl(pi)";
[__ref _showpageimpl /*NSString**/ :nil :_pi];
 };
B4IRDebugUtils.currentLine=5308442;
 //BA.debugLineNum = 5308442;BA.debugLine="TopPageAppear";
[__ref _toppageappear /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5308443;
 //BA.debugLineNum = 5308443;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _activity_pause:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
B4IRDebugUtils.currentLine=7012352;
 //BA.debugLineNum = 7012352;BA.debugLine="Public Sub Activity_Pause";
B4IRDebugUtils.currentLine=7012353;
 //BA.debugLineNum = 7012353;BA.debugLine="RaiseEventWithResult(GetTopPage, \"B4XPage_Disappe";
[__ref _raiseeventwithresult /*NSObject**/ :nil :[__ref _gettoppage /*_b4xpageinfo**/ :nil] :@"B4XPage_Disappear" :(B4IArray*)(nil)];
B4IRDebugUtils.currentLine=7012354;
 //BA.debugLineNum = 7012354;BA.debugLine="BackgroundStateChanged(False)";
[__ref _backgroundstatechanged /*NSString**/ :nil :false];
B4IRDebugUtils.currentLine=7012355;
 //BA.debugLineNum = 7012355;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _activity_resume:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"activity_resume"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"activity_resume" :nil]);}
BOOL _shouldraise = false;
B4IRDebugUtils.currentLine=6881280;
 //BA.debugLineNum = 6881280;BA.debugLine="Public Sub Activity_Resume";
B4IRDebugUtils.currentLine=6881281;
 //BA.debugLineNum = 6881281;BA.debugLine="Dim ShouldRaise As Boolean = IsForeground = False";
_shouldraise = __ref->__isforeground /*BOOL*/ ==false;
B4IRDebugUtils.currentLine=6881282;
 //BA.debugLineNum = 6881282;BA.debugLine="BackgroundStateChanged(True)";
[__ref _backgroundstatechanged /*NSString**/ :nil :true];
B4IRDebugUtils.currentLine=6881283;
 //BA.debugLineNum = 6881283;BA.debugLine="If ShouldRaise Then";
if (_shouldraise) { 
B4IRDebugUtils.currentLine=6881284;
 //BA.debugLineNum = 6881284;BA.debugLine="RaiseEvent(GetTopPage, \"B4XPage_Appear\", Null)";
[__ref _raiseevent /*NSString**/ :nil :[__ref _gettoppage /*_b4xpageinfo**/ :nil] :@"B4XPage_Appear" :(B4IArray*)(nil)];
 };
B4IRDebugUtils.currentLine=6881286;
 //BA.debugLineNum = 6881286;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _mainform_resize:(b4i_b4xpagesmanager*) __ref :(double) _width :(double) _height{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"mainform_resize"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"mainform_resize::" :@[@(_width),@(_height)]]);}
int _w = 0;
int _h = 0;
B4IRDebugUtils.currentLine=6684672;
 //BA.debugLineNum = 6684672;BA.debugLine="Public Sub MainForm_Resize(Width As Double, Height";
B4IRDebugUtils.currentLine=6684673;
 //BA.debugLineNum = 6684673;BA.debugLine="Dim w As Int = Width";
_w = (int) (_width);
B4IRDebugUtils.currentLine=6684674;
 //BA.debugLineNum = 6684674;BA.debugLine="Dim h As Int = Height";
_h = (int) (_height);
B4IRDebugUtils.currentLine=6684675;
 //BA.debugLineNum = 6684675;BA.debugLine="RaiseEvent(GetPageInfoFromRoot(Sender), \"B4XPage_";
[__ref _raiseevent /*NSString**/ :nil :[__ref _getpageinfofromroot /*_b4xpageinfo**/ :nil :(B4XViewWrapper*) [B4IObjectWrapper createWrapper:[B4XViewWrapper new] object:(NSObject*)([self->___c Sender:self.bi])]] :@"B4XPage_Resize" :[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(@(_w))],[B4I nilToNSNull:(NSObject*)(@(_h))]]]];
B4IRDebugUtils.currentLine=6684676;
 //BA.debugLineNum = 6684676;BA.debugLine="End Sub";
return @"";
}
- (NSObject*)  _raiseeventwithresult:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _targetpage :(NSString*) _subname :(B4IArray*) _params{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"raiseeventwithresult"])
	 {return ((NSObject*) [B4IDebug delegate:self.bi :@"raiseeventwithresult:::" :@[[B4I nilToNSNull:_targetpage],[B4I nilToNSNull:_subname],[B4I nilToNSNull:_params]]]);}
int _length = 0;
B4IRDebugUtils.currentLine=6619136;
 //BA.debugLineNum = 6619136;BA.debugLine="Public Sub RaiseEventWithResult (TargetPage As B4X";
B4IRDebugUtils.currentLine=6619137;
 //BA.debugLineNum = 6619137;BA.debugLine="If TargetPage = Null Then Return Null";
if (_targetpage== nil) { 
if (true) return nil;};
B4IRDebugUtils.currentLine=6619138;
 //BA.debugLineNum = 6619138;BA.debugLine="Dim length As Int";
_length = 0;
B4IRDebugUtils.currentLine=6619139;
 //BA.debugLineNum = 6619139;BA.debugLine="If Params = Null Then length = 0 Else length = Pa";
if (_params== nil) { 
_length = (int) (0);}
else {
_length = _params.Length;};
B4IRDebugUtils.currentLine=6619140;
 //BA.debugLineNum = 6619140;BA.debugLine="LogEvent(TargetPage, SubName)";
[__ref _logevent /*NSString**/ :nil :_targetpage :_subname];
B4IRDebugUtils.currentLine=6619141;
 //BA.debugLineNum = 6619141;BA.debugLine="If xui.SubExists(TargetPage.B4XPage, SubName, len";
if ([__ref->__xui /*B4IXUI**/  SubExists:_targetpage->_B4XPage /*NSObject**/  :_subname :_length]==false) { 
if (true) return nil;};
B4IRDebugUtils.currentLine=6619142;
 //BA.debugLineNum = 6619142;BA.debugLine="Select length";
switch (_length) {
case 0: {
B4IRDebugUtils.currentLine=6619144;
 //BA.debugLineNum = 6619144;BA.debugLine="Return CallSub(TargetPage.B4XPage, SubName)";
if (true) return [self->___c CallSub:self.bi :_targetpage->_B4XPage /*NSObject**/  :_subname];
 break; }
case 1: {
B4IRDebugUtils.currentLine=6619146;
 //BA.debugLineNum = 6619146;BA.debugLine="Return CallSub2(TargetPage.B4XPage, SubName, Pa";
if (true) return [self->___c CallSub2:self.bi :_targetpage->_B4XPage /*NSObject**/  :_subname :((NSObject*)[_params getObjectFast:(int) (0)])];
 break; }
case 2: {
B4IRDebugUtils.currentLine=6619148;
 //BA.debugLineNum = 6619148;BA.debugLine="Return CallSub3(TargetPage.B4XPage, SubName, Pa";
if (true) return [self->___c CallSub3:self.bi :_targetpage->_B4XPage /*NSObject**/  :_subname :((NSObject*)[_params getObjectFast:(int) (0)]) :((NSObject*)[_params getObjectFast:(int) (1)])];
 break; }
default: {
B4IRDebugUtils.currentLine=6619150;
 //BA.debugLineNum = 6619150;BA.debugLine="Log(\"Too many parameters\")";
[self->___c LogImpl:@"96619150" :@"Too many parameters" :0];
 break; }
}
;
B4IRDebugUtils.currentLine=6619152;
 //BA.debugLineNum = 6619152;BA.debugLine="Return Null";
if (true) return nil;
B4IRDebugUtils.currentLine=6619153;
 //BA.debugLineNum = 6619153;BA.debugLine="End Sub";
return nil;
}
- (_b4xpageinfo*)  _gettoppage:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"gettoppage"])
	 {return ((_b4xpageinfo*) [B4IDebug delegate:self.bi :@"gettoppage" :nil]);}
B4IRDebugUtils.currentLine=6750208;
 //BA.debugLineNum = 6750208;BA.debugLine="Public Sub GetTopPage As B4XPageInfo";
B4IRDebugUtils.currentLine=6750209;
 //BA.debugLineNum = 6750209;BA.debugLine="If mStackOfPageIds.Size = 0 Then Return Null";
if ([__ref->__mstackofpageids /*b4i_b4xset**/  _getsize /*int*/ :nil]==0) { 
if (true) return (_b4xpageinfo*)(nil);};
B4IRDebugUtils.currentLine=6750210;
 //BA.debugLineNum = 6750210;BA.debugLine="Return IdToB4XPage.Get(mStackOfPageIds.AsList.Get";
if (true) return (_b4xpageinfo*)([__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _get /*NSObject**/ :nil :[[__ref->__mstackofpageids /*b4i_b4xset**/  _aslist /*B4IList**/ :nil] Get:(int) ([__ref->__mstackofpageids /*b4i_b4xset**/  _getsize /*int*/ :nil]-1)]]);
B4IRDebugUtils.currentLine=6750211;
 //BA.debugLineNum = 6750211;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _backgroundstatechanged:(b4i_b4xpagesmanager*) __ref :(BOOL) _newstate{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"backgroundstatechanged"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"backgroundstatechanged:" :@[@(_newstate)]]);}
NSString* _ev = @"";
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=6946816;
 //BA.debugLineNum = 6946816;BA.debugLine="Private Sub BackgroundStateChanged (NewState As Bo";
B4IRDebugUtils.currentLine=6946817;
 //BA.debugLineNum = 6946817;BA.debugLine="If IsForeground = NewState Then Return";
if (__ref->__isforeground /*BOOL*/ ==_newstate) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=6946818;
 //BA.debugLineNum = 6946818;BA.debugLine="IsForeground = NewState";
__ref->__isforeground /*BOOL*/  = _newstate;
B4IRDebugUtils.currentLine=6946819;
 //BA.debugLineNum = 6946819;BA.debugLine="Dim ev As String";
_ev = @"";
B4IRDebugUtils.currentLine=6946820;
 //BA.debugLineNum = 6946820;BA.debugLine="If IsForeground Then ev = \"B4XPage_Foreground\" El";
if (__ref->__isforeground /*BOOL*/ ) { 
_ev = @"B4XPage_Foreground";}
else {
_ev = @"B4XPage_Background";};
B4IRDebugUtils.currentLine=6946821;
 //BA.debugLineNum = 6946821;BA.debugLine="For Each pi As B4XPageInfo In IdToB4XPage.Values";
{
const id<B4IIterable> group5 = [__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _getvalues /*B4IList**/ :nil];
const int groupLen5 = group5.Size
;int index5 = 0;
;
for (; index5 < groupLen5;index5++){
_pi = (_b4xpageinfo*)([group5 Get:index5]);
B4IRDebugUtils.currentLine=6946822;
 //BA.debugLineNum = 6946822;BA.debugLine="If xui.SubExists(pi.B4XPage, ev, 0) Then";
if ([__ref->__xui /*B4IXUI**/  SubExists:_pi->_B4XPage /*NSObject**/  :_ev :(int) (0)]) { 
B4IRDebugUtils.currentLine=6946823;
 //BA.debugLineNum = 6946823;BA.debugLine="LogEvent(pi, ev)";
[__ref _logevent /*NSString**/ :nil :_pi :_ev];
B4IRDebugUtils.currentLine=6946824;
 //BA.debugLineNum = 6946824;BA.debugLine="If IsForeground Then";
if (__ref->__isforeground /*BOOL*/ ) { 
B4IRDebugUtils.currentLine=6946825;
 //BA.debugLineNum = 6946825;BA.debugLine="CallSubDelayed(pi.B4XPage, ev)";
[self->___c CallSubDelayed:self.bi :_pi->_B4XPage /*NSObject**/  :_ev];
 }else {
B4IRDebugUtils.currentLine=6946827;
 //BA.debugLineNum = 6946827;BA.debugLine="CallSub(pi.B4XPage, ev)";
[self->___c CallSub:self.bi :_pi->_B4XPage /*NSObject**/  :_ev];
 };
 };
 }
};
B4IRDebugUtils.currentLine=6946831;
 //BA.debugLineNum = 6946831;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _raiseevent:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _targetpage :(NSString*) _subname :(B4IArray*) _params{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"raiseevent"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"raiseevent:::" :@[[B4I nilToNSNull:_targetpage],[B4I nilToNSNull:_subname],[B4I nilToNSNull:_params]]]);}
int _length = 0;
B4IRDebugUtils.currentLine=6553600;
 //BA.debugLineNum = 6553600;BA.debugLine="Public Sub RaiseEvent (TargetPage As B4XPageInfo,";
B4IRDebugUtils.currentLine=6553601;
 //BA.debugLineNum = 6553601;BA.debugLine="If TargetPage = Null Then Return";
if (_targetpage== nil) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=6553602;
 //BA.debugLineNum = 6553602;BA.debugLine="Dim length As Int";
_length = 0;
B4IRDebugUtils.currentLine=6553603;
 //BA.debugLineNum = 6553603;BA.debugLine="If Params = Null Then length = 0 Else length = Pa";
if (_params== nil) { 
_length = (int) (0);}
else {
_length = _params.Length;};
B4IRDebugUtils.currentLine=6553604;
 //BA.debugLineNum = 6553604;BA.debugLine="LogEvent(TargetPage, SubName)";
[__ref _logevent /*NSString**/ :nil :_targetpage :_subname];
B4IRDebugUtils.currentLine=6553605;
 //BA.debugLineNum = 6553605;BA.debugLine="If xui.SubExists(TargetPage.B4XPage, SubName, len";
if ([__ref->__xui /*B4IXUI**/  SubExists:_targetpage->_B4XPage /*NSObject**/  :_subname :_length]==false) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=6553606;
 //BA.debugLineNum = 6553606;BA.debugLine="Select length";
switch (_length) {
case 0: {
B4IRDebugUtils.currentLine=6553608;
 //BA.debugLineNum = 6553608;BA.debugLine="CallSubDelayed(TargetPage.B4XPage, SubName)";
[self->___c CallSubDelayed:self.bi :_targetpage->_B4XPage /*NSObject**/  :_subname];
 break; }
case 1: {
B4IRDebugUtils.currentLine=6553610;
 //BA.debugLineNum = 6553610;BA.debugLine="CallSubDelayed2(TargetPage.B4XPage, SubName, Pa";
[self->___c CallSubDelayed2:self.bi :_targetpage->_B4XPage /*NSObject**/  :_subname :((NSObject*)[_params getObjectFast:(int) (0)])];
 break; }
case 2: {
B4IRDebugUtils.currentLine=6553612;
 //BA.debugLineNum = 6553612;BA.debugLine="CallSubDelayed3(TargetPage.B4XPage, SubName, Pa";
[self->___c CallSubDelayed3:self.bi :_targetpage->_B4XPage /*NSObject**/  :_subname :((NSObject*)[_params getObjectFast:(int) (0)]) :((NSObject*)[_params getObjectFast:(int) (1)])];
 break; }
default: {
B4IRDebugUtils.currentLine=6553614;
 //BA.debugLineNum = 6553614;BA.debugLine="Log(\"Too many parameters\")";
[self->___c LogImpl:@"96553614" :@"Too many parameters" :0];
 break; }
}
;
B4IRDebugUtils.currentLine=6553616;
 //BA.debugLineNum = 6553616;BA.debugLine="End Sub";
return @"";
}
- (_b4xpageinfo*)  _createb4xpageinfo:(b4i_b4xpagesmanager*) __ref :(NSObject*) _b4xpage :(NSString*) _id :(BOOL) _created :(NSObject*) _title{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"createb4xpageinfo"])
	 {return ((_b4xpageinfo*) [B4IDebug delegate:self.bi :@"createb4xpageinfo::::" :@[[B4I nilToNSNull:_b4xpage],[B4I nilToNSNull:_id],@(_created),[B4I nilToNSNull:_title]]]);}
_b4xpageinfo* _t1 = nil;
B4IRDebugUtils.currentLine=6488064;
 //BA.debugLineNum = 6488064;BA.debugLine="Private Sub CreateB4XPageInfo (B4XPage As Object,";
B4IRDebugUtils.currentLine=6488065;
 //BA.debugLineNum = 6488065;BA.debugLine="Dim t1 As B4XPageInfo";
_t1 = [_b4xpageinfo new];
B4IRDebugUtils.currentLine=6488066;
 //BA.debugLineNum = 6488066;BA.debugLine="t1.Initialize";
[_t1 Initialize];
B4IRDebugUtils.currentLine=6488067;
 //BA.debugLineNum = 6488067;BA.debugLine="t1.B4XPage = B4XPage";
_t1->_B4XPage /*NSObject**/  = _b4xpage;
B4IRDebugUtils.currentLine=6488068;
 //BA.debugLineNum = 6488068;BA.debugLine="t1.Id = Id";
_t1->_Id /*NSString**/  = _id;
B4IRDebugUtils.currentLine=6488069;
 //BA.debugLineNum = 6488069;BA.debugLine="t1.Created = Created";
_t1->_Created /*BOOL*/  = _created;
B4IRDebugUtils.currentLine=6488070;
 //BA.debugLineNum = 6488070;BA.debugLine="t1.Title = Title";
_t1->_Title /*NSObject**/  = _title;
B4IRDebugUtils.currentLine=6488071;
 //BA.debugLineNum = 6488071;BA.debugLine="Return t1";
if (true) return _t1;
B4IRDebugUtils.currentLine=6488072;
 //BA.debugLineNum = 6488072;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _createpageifneeded:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _pi{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"createpageifneeded"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"createpageifneeded:" :@[[B4I nilToNSNull:_pi]]]);}
B4IRDebugUtils.currentLine=6094848;
 //BA.debugLineNum = 6094848;BA.debugLine="Private Sub CreatePageIfNeeded(pi As B4XPageInfo)";
B4IRDebugUtils.currentLine=6094849;
 //BA.debugLineNum = 6094849;BA.debugLine="If pi.Created Then Return";
if (_pi->_Created /*BOOL*/ ) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=6094850;
 //BA.debugLineNum = 6094850;BA.debugLine="pi.IsFirst = IdToB4XPage.Size = 1";
_pi->_IsFirst /*BOOL*/  = [__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _getsize /*int*/ :nil]==1;
B4IRDebugUtils.currentLine=6094851;
 //BA.debugLineNum = 6094851;BA.debugLine="CreatePageImpl (pi)";
[__ref _createpageimpl /*NSString**/ :nil :_pi];
B4IRDebugUtils.currentLine=6094852;
 //BA.debugLineNum = 6094852;BA.debugLine="pi.Created = True";
_pi->_Created /*BOOL*/  = true;
B4IRDebugUtils.currentLine=6094853;
 //BA.debugLineNum = 6094853;BA.debugLine="RootB4XToPage.Put(pi.Root, pi)";
[__ref->__rootb4xtopage /*b4i_b4xorderedmap**/  _put /*NSString**/ :nil :(NSObject*)((_pi->_Root /*B4XViewWrapper**/ ).object) :(NSObject*)(_pi)];
B4IRDebugUtils.currentLine=6094854;
 //BA.debugLineNum = 6094854;BA.debugLine="LogEvent(pi, \"B4XPage_Created\")";
[__ref _logevent /*NSString**/ :nil :_pi :@"B4XPage_Created"];
B4IRDebugUtils.currentLine=6094855;
 //BA.debugLineNum = 6094855;BA.debugLine="CallSub2(pi.B4XPage, \"B4XPage_Created\", pi.root)";
[self->___c CallSubDebug2:self.bi :_pi->_B4XPage /*NSObject**/  :@"B4XPage_Created" :(NSObject*)(_pi->_Root /*B4XViewWrapper**/ )];
B4IRDebugUtils.currentLine=6094857;
 //BA.debugLineNum = 6094857;BA.debugLine="End Sub";
return @"";
}
- (_b4xpageinfo*)  _getpagefromid:(b4i_b4xpagesmanager*) __ref :(NSString*) _id{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"getpagefromid"])
	 {return ((_b4xpageinfo*) [B4IDebug delegate:self.bi :@"getpagefromid:" :@[[B4I nilToNSNull:_id]]]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=6356992;
 //BA.debugLineNum = 6356992;BA.debugLine="Private Sub GetPageFromId (id As String) As B4XPag";
B4IRDebugUtils.currentLine=6356993;
 //BA.debugLineNum = 6356993;BA.debugLine="Dim pi As B4XPageInfo = IdToB4XPage.Get(id.ToLowe";
_pi = (_b4xpageinfo*)([__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _get /*NSObject**/ :nil :(NSObject*)([_id ToLowerCase])]);
B4IRDebugUtils.currentLine=6356994;
 //BA.debugLineNum = 6356994;BA.debugLine="If pi = Null Then";
if (_pi== nil) { 
B4IRDebugUtils.currentLine=6356995;
 //BA.debugLineNum = 6356995;BA.debugLine="Log(\"Error: page id not found: \" & id)";
[self->___c LogImpl:@"96356995" :[@[@"Error: page id not found: ",_id] componentsJoinedByString:@""] :0];
B4IRDebugUtils.currentLine=6356996;
 //BA.debugLineNum = 6356996;BA.debugLine="Log(\"Ids: \" & IdToB4XPage.Keys) 'ignore";
[self->___c LogImpl:@"96356996" :[@[@"Ids: ",[self.bi ObjectToString:[__ref->__idtob4xpage /*b4i_b4xorderedmap**/  _getkeys /*B4IList**/ :nil]]] componentsJoinedByString:@""] :0];
 };
B4IRDebugUtils.currentLine=6356998;
 //BA.debugLineNum = 6356998;BA.debugLine="Return pi";
if (true) return _pi;
B4IRDebugUtils.currentLine=6356999;
 //BA.debugLineNum = 6356999;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _b4ipage_appear:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"b4ipage_appear"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"b4ipage_appear" :nil]);}
B4IPage* _page = nil;
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5439488;
 //BA.debugLineNum = 5439488;BA.debugLine="Private Sub B4iPage_Appear";
B4IRDebugUtils.currentLine=5439489;
 //BA.debugLineNum = 5439489;BA.debugLine="Dim page As Page = Sender";
_page = [B4IPage new];
_page = (B4IPage*) [B4IObjectWrapper createWrapper:[B4IPage new] object:(UIViewController*)([self->___c Sender:self.bi])];
B4IRDebugUtils.currentLine=5439490;
 //BA.debugLineNum = 5439490;BA.debugLine="Dim pi As B4XPageInfo = RootB4XToPage.Get(page.Ro";
_pi = (_b4xpageinfo*)([__ref->__rootb4xtopage /*b4i_b4xorderedmap**/  _get /*NSObject**/ :nil :(NSObject*)(([_page RootPanel]).object)]);
B4IRDebugUtils.currentLine=5439491;
 //BA.debugLineNum = 5439491;BA.debugLine="mStackOfPageIds.Add(pi.Id)";
[__ref->__mstackofpageids /*b4i_b4xset**/  _add /*NSString**/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )];
B4IRDebugUtils.currentLine=5439492;
 //BA.debugLineNum = 5439492;BA.debugLine="UpdateStackString";
[__ref _updatestackstring /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5439493;
 //BA.debugLineNum = 5439493;BA.debugLine="RaiseEvent(pi, \"B4XPage_Appear\", Null)";
[__ref _raiseevent /*NSString**/ :nil :_pi :@"B4XPage_Appear" :(B4IArray*)(nil)];
B4IRDebugUtils.currentLine=5439494;
 //BA.debugLineNum = 5439494;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _updatestackstring:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"updatestackstring"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"updatestackstring" :nil]);}
B4IStringBuilder* _sb = nil;
NSString* _id = @"";
B4IRDebugUtils.currentLine=7143424;
 //BA.debugLineNum = 7143424;BA.debugLine="Public Sub UpdateStackString";
B4IRDebugUtils.currentLine=7143425;
 //BA.debugLineNum = 7143425;BA.debugLine="Dim sb As StringBuilder";
_sb = [B4IStringBuilder new];
B4IRDebugUtils.currentLine=7143426;
 //BA.debugLineNum = 7143426;BA.debugLine="sb.Initialize";
[_sb Initialize];
B4IRDebugUtils.currentLine=7143427;
 //BA.debugLineNum = 7143427;BA.debugLine="sb.Append(\"[\")";
[_sb Append:@"["];
B4IRDebugUtils.currentLine=7143428;
 //BA.debugLineNum = 7143428;BA.debugLine="If mStackOfPageIds.Size > 0 Then";
if ([__ref->__mstackofpageids /*b4i_b4xset**/  _getsize /*int*/ :nil]>0) { 
B4IRDebugUtils.currentLine=7143429;
 //BA.debugLineNum = 7143429;BA.debugLine="For Each id As String In mStackOfPageIds.AsList";
{
const id<B4IIterable> group5 = [__ref->__mstackofpageids /*b4i_b4xset**/  _aslist /*B4IList**/ :nil];
const int groupLen5 = group5.Size
;int index5 = 0;
;
for (; index5 < groupLen5;index5++){
_id = [self.bi ObjectToString:[group5 Get:index5]];
B4IRDebugUtils.currentLine=7143430;
 //BA.debugLineNum = 7143430;BA.debugLine="sb.Append(id).Append(\", \")";
[[_sb Append:_id] Append:@", "];
 }
};
B4IRDebugUtils.currentLine=7143432;
 //BA.debugLineNum = 7143432;BA.debugLine="sb.Remove(sb.Length - 2, sb.Length)";
[_sb Remove:(int) ([_sb Length]-2) :[_sb Length]];
 };
B4IRDebugUtils.currentLine=7143434;
 //BA.debugLineNum = 7143434;BA.debugLine="sb.Append(\"]\")";
[_sb Append:@"]"];
B4IRDebugUtils.currentLine=7143435;
 //BA.debugLineNum = 7143435;BA.debugLine="StackString = sb.ToString";
__ref->__stackstring /*NSString**/  = [_sb ToString];
B4IRDebugUtils.currentLine=7143436;
 //BA.debugLineNum = 7143436;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _b4ipage_barbuttonclick:(b4i_b4xpagesmanager*) __ref :(NSString*) _tag{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"b4ipage_barbuttonclick"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"b4ipage_barbuttonclick:" :@[[B4I nilToNSNull:_tag]]]);}
B4IPage* _page = nil;
B4IRDebugUtils.currentLine=5701632;
 //BA.debugLineNum = 5701632;BA.debugLine="Private Sub B4iPage_BarButtonClick (Tag As String)";
B4IRDebugUtils.currentLine=5701633;
 //BA.debugLineNum = 5701633;BA.debugLine="Dim page As Page = Sender";
_page = [B4IPage new];
_page = (B4IPage*) [B4IObjectWrapper createWrapper:[B4IPage new] object:(UIViewController*)([self->___c Sender:self.bi])];
B4IRDebugUtils.currentLine=5701634;
 //BA.debugLineNum = 5701634;BA.debugLine="RaiseEvent(GetPageInfoFromRoot(page.RootPanel), \"";
[__ref _raiseevent /*NSString**/ :nil :[__ref _getpageinfofromroot /*_b4xpageinfo**/ :nil :(B4XViewWrapper*) [B4IObjectWrapper createWrapper:[B4XViewWrapper new] object:(NSObject*)(([_page RootPanel]).object)]] :@"B4XPage_MenuClick" :[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(_tag)]]]];
B4IRDebugUtils.currentLine=5701635;
 //BA.debugLineNum = 5701635;BA.debugLine="End Sub";
return @"";
}
- (_b4xpageinfo*)  _getpageinfofromroot:(b4i_b4xpagesmanager*) __ref :(B4XViewWrapper*) _root{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"getpageinfofromroot"])
	 {return ((_b4xpageinfo*) [B4IDebug delegate:self.bi :@"getpageinfofromroot:" :@[[B4I nilToNSNull:_root]]]);}
B4IRDebugUtils.currentLine=6422528;
 //BA.debugLineNum = 6422528;BA.debugLine="Public Sub GetPageInfoFromRoot (Root As B4XView) A";
B4IRDebugUtils.currentLine=6422529;
 //BA.debugLineNum = 6422529;BA.debugLine="Return RootB4XToPage.Get(Root)";
if (true) return (_b4xpageinfo*)([__ref->__rootb4xtopage /*b4i_b4xorderedmap**/  _get /*NSObject**/ :nil :(NSObject*)((_root).object)]);
B4IRDebugUtils.currentLine=6422530;
 //BA.debugLineNum = 6422530;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _b4ipage_disappear:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"b4ipage_disappear"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"b4ipage_disappear" :nil]);}
B4IPage* _page = nil;
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5505024;
 //BA.debugLineNum = 5505024;BA.debugLine="Private Sub B4iPage_Disappear";
B4IRDebugUtils.currentLine=5505025;
 //BA.debugLineNum = 5505025;BA.debugLine="Dim page As Page = Sender";
_page = [B4IPage new];
_page = (B4IPage*) [B4IObjectWrapper createWrapper:[B4IPage new] object:(UIViewController*)([self->___c Sender:self.bi])];
B4IRDebugUtils.currentLine=5505026;
 //BA.debugLineNum = 5505026;BA.debugLine="Dim pi As B4XPageInfo = RootB4XToPage.Get(page.Ro";
_pi = (_b4xpageinfo*)([__ref->__rootb4xtopage /*b4i_b4xorderedmap**/  _get /*NSObject**/ :nil :(NSObject*)(([_page RootPanel]).object)]);
B4IRDebugUtils.currentLine=5505027;
 //BA.debugLineNum = 5505027;BA.debugLine="RaiseEvent(pi, \"B4XPage_Disappear\", Null)";
[__ref _raiseevent /*NSString**/ :nil :_pi :@"B4XPage_Disappear" :(B4IArray*)(nil)];
B4IRDebugUtils.currentLine=5505028;
 //BA.debugLineNum = 5505028;BA.debugLine="If GetTopPage = pi Then";
if ([[__ref _gettoppage /*_b4xpageinfo**/ :nil] isEqual:_pi]) { 
B4IRDebugUtils.currentLine=5505029;
 //BA.debugLineNum = 5505029;BA.debugLine="mStackOfPageIds.Remove(pi.Id)";
[__ref->__mstackofpageids /*b4i_b4xset**/  _remove /*NSString**/ :nil :(NSObject*)(_pi->_Id /*NSString**/ )];
 };
B4IRDebugUtils.currentLine=5505031;
 //BA.debugLineNum = 5505031;BA.debugLine="UpdateStackString";
[__ref _updatestackstring /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5505032;
 //BA.debugLineNum = 5505032;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _b4ipage_keyboardstatechanged:(b4i_b4xpagesmanager*) __ref :(float) _height{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"b4ipage_keyboardstatechanged"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"b4ipage_keyboardstatechanged:" :@[@(_height)]]);}
B4IPage* _page = nil;
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5636096;
 //BA.debugLineNum = 5636096;BA.debugLine="Private Sub B4iPage_KeyboardStateChanged (Height A";
B4IRDebugUtils.currentLine=5636097;
 //BA.debugLineNum = 5636097;BA.debugLine="Dim page As Page";
_page = [B4IPage new];
B4IRDebugUtils.currentLine=5636098;
 //BA.debugLineNum = 5636098;BA.debugLine="If (Sender Is Page) = False Then";
if (([[self->___c Sender:self.bi] isKindOfClass: [UIViewController class]])==false) { 
B4IRDebugUtils.currentLine=5636099;
 //BA.debugLineNum = 5636099;BA.debugLine="Dim pi As B4XPageInfo = GetTopPage";
_pi = [__ref _gettoppage /*_b4xpageinfo**/ :nil];
B4IRDebugUtils.currentLine=5636100;
 //BA.debugLineNum = 5636100;BA.debugLine="If pi <> Null Then";
if (_pi!= nil) { 
B4IRDebugUtils.currentLine=5636101;
 //BA.debugLineNum = 5636101;BA.debugLine="page = pi.Parent.NativeType";
_page = _pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/ ;
 };
 }else {
B4IRDebugUtils.currentLine=5636104;
 //BA.debugLineNum = 5636104;BA.debugLine="page = Sender";
_page = (B4IPage*) [B4IObjectWrapper createWrapper:[B4IPage new] object:(UIViewController*)([self->___c Sender:self.bi])];
 };
B4IRDebugUtils.currentLine=5636106;
 //BA.debugLineNum = 5636106;BA.debugLine="If page.IsInitialized Then";
if ([_page IsInitialized]) { 
B4IRDebugUtils.currentLine=5636107;
 //BA.debugLineNum = 5636107;BA.debugLine="RaiseEvent(GetPageInfoFromRoot(page.RootPanel),";
[__ref _raiseevent /*NSString**/ :nil :[__ref _getpageinfofromroot /*_b4xpageinfo**/ :nil :(B4XViewWrapper*) [B4IObjectWrapper createWrapper:[B4XViewWrapper new] object:(NSObject*)(([_page RootPanel]).object)]] :@"B4XPage_KeyboardStateChanged" :[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(@(_height))]]]];
 };
B4IRDebugUtils.currentLine=5636109;
 //BA.debugLineNum = 5636109;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _b4ipage_resize:(b4i_b4xpagesmanager*) __ref :(float) _width :(float) _height{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"b4ipage_resize"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"b4ipage_resize::" :@[@(_width),@(_height)]]);}
B4IRDebugUtils.currentLine=5570560;
 //BA.debugLineNum = 5570560;BA.debugLine="Private Sub B4iPage_Resize (Width As Float, Height";
B4IRDebugUtils.currentLine=5570561;
 //BA.debugLineNum = 5570561;BA.debugLine="RaiseEvent(GetPageInfoFromRoot(Sender), \"B4XPage_";
[__ref _raiseevent /*NSString**/ :nil :[__ref _getpageinfofromroot /*_b4xpageinfo**/ :nil :(B4XViewWrapper*) [B4IObjectWrapper createWrapper:[B4XViewWrapper new] object:(NSObject*)([self->___c Sender:self.bi])]] :@"B4XPage_Resize" :[[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(@(_width))],[B4I nilToNSNull:(NSObject*)(@(_height))]]]];
B4IRDebugUtils.currentLine=5570562;
 //BA.debugLineNum = 5570562;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _logevent:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _pi :(NSString*) _ev{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"logevent"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"logevent::" :@[[B4I nilToNSNull:_pi],[B4I nilToNSNull:_ev]]]);}
NSString* _msg = @"";
B4IRDebugUtils.currentLine=7077888;
 //BA.debugLineNum = 7077888;BA.debugLine="Private Sub LogEvent (pi As B4XPageInfo, ev As Str";
B4IRDebugUtils.currentLine=7077889;
 //BA.debugLineNum = 7077889;BA.debugLine="If LogEvents Then";
if (__ref->__logevents /*BOOL*/ ) { 
B4IRDebugUtils.currentLine=7077890;
 //BA.debugLineNum = 7077890;BA.debugLine="Dim msg As String = $\"*** ${pi.Id}: ${ev} ${Stac";
_msg = ([@[@"*** ",[self->___c SmartStringFormatter:@"" :(NSObject*)(_pi->_Id /*NSString**/ )],@": ",[self->___c SmartStringFormatter:@"" :(NSObject*)(_ev)],@" ",[self->___c SmartStringFormatter:@"" :(NSObject*)(__ref->__stackstring /*NSString**/ )],@""] componentsJoinedByString:@""]);
B4IRDebugUtils.currentLine=7077891;
 //BA.debugLineNum = 7077891;BA.debugLine="Log(msg)";
[self->___c LogImpl:@"97077891" :_msg :0];
 };
B4IRDebugUtils.currentLine=7077893;
 //BA.debugLineNum = 7077893;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _class_globals:(b4i_b4xpagesmanager*) __ref{
__ref = self;
self->__main=[b4i_main new];
self->__b4xpages=[b4i_b4xpages new];
self->__b4xcollections=[b4i_b4xcollections new];
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
B4IRDebugUtils.currentLine=4980736;
 //BA.debugLineNum = 4980736;BA.debugLine="Sub Class_Globals";
B4IRDebugUtils.currentLine=4980737;
 //BA.debugLineNum = 4980737;BA.debugLine="Private IdToB4XPage As B4XOrderedMap";
self->__idtob4xpage = [b4i_b4xorderedmap new];
B4IRDebugUtils.currentLine=4980738;
 //BA.debugLineNum = 4980738;BA.debugLine="Private RootB4XToPage As B4XOrderedMap";
self->__rootb4xtopage = [b4i_b4xorderedmap new];
B4IRDebugUtils.currentLine=4980746;
 //BA.debugLineNum = 4980746;BA.debugLine="Type B4XPageParent (NativeType As Page)";
;
B4IRDebugUtils.currentLine=4980748;
 //BA.debugLineNum = 4980748;BA.debugLine="Type B4XPageInfo (B4XPage As Object, Id As String";
;
B4IRDebugUtils.currentLine=4980752;
 //BA.debugLineNum = 4980752;BA.debugLine="Public mStackOfPageIds As B4XSet";
self->__mstackofpageids = [b4i_b4xset new];
B4IRDebugUtils.currentLine=4980753;
 //BA.debugLineNum = 4980753;BA.debugLine="Private xui As XUI 'ignore";
self->__xui = [B4IXUI new];
B4IRDebugUtils.currentLine=4980761;
 //BA.debugLineNum = 4980761;BA.debugLine="Private mMainForm As NavigationController";
self->__mmainform = [B4INavigationControllerWrapper new];
B4IRDebugUtils.currentLine=4980763;
 //BA.debugLineNum = 4980763;BA.debugLine="Public IsForeground As Boolean";
self->__isforeground = false;
B4IRDebugUtils.currentLine=4980764;
 //BA.debugLineNum = 4980764;BA.debugLine="Public TransitionAnimationDuration As Int = 100";
self->__transitionanimationduration = (int) (100);
B4IRDebugUtils.currentLine=4980765;
 //BA.debugLineNum = 4980765;BA.debugLine="Public MainPage As B4XMainPage";
self->__mainpage = [b4i_b4xmainpage new];
B4IRDebugUtils.currentLine=4980766;
 //BA.debugLineNum = 4980766;BA.debugLine="Private StackString As String";
self->__stackstring = @"";
B4IRDebugUtils.currentLine=4980767;
 //BA.debugLineNum = 4980767;BA.debugLine="Public LogEvents As Boolean = False";
self->__logevents = false;
B4IRDebugUtils.currentLine=4980768;
 //BA.debugLineNum = 4980768;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _closepageimpl:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _pi{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"closepageimpl"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"closepageimpl:" :@[[B4I nilToNSNull:_pi]]]);}
B4IRDebugUtils.currentLine=5963776;
 //BA.debugLineNum = 5963776;BA.debugLine="Private Sub ClosePageImpl (pi As B4XPageInfo) 'ign";
B4IRDebugUtils.currentLine=5963790;
 //BA.debugLineNum = 5963790;BA.debugLine="mMainForm.RemoveCurrentPage2(TransitionAnimationD";
[__ref->__mmainform /*B4INavigationControllerWrapper**/  RemoveCurrentPage2:__ref->__transitionanimationduration /*int*/ >0];
B4IRDebugUtils.currentLine=5963792;
 //BA.debugLineNum = 5963792;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _toppagedisappear:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"toppagedisappear"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"toppagedisappear" :nil]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5767168;
 //BA.debugLineNum = 5767168;BA.debugLine="Private Sub TopPageDisappear";
B4IRDebugUtils.currentLine=5767169;
 //BA.debugLineNum = 5767169;BA.debugLine="If xui.IsB4J Then Return";
if ([__ref->__xui /*B4IXUI**/  IsB4J]) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=5767170;
 //BA.debugLineNum = 5767170;BA.debugLine="Dim pi As B4XPageInfo = GetTopPage";
_pi = [__ref _gettoppage /*_b4xpageinfo**/ :nil];
B4IRDebugUtils.currentLine=5767171;
 //BA.debugLineNum = 5767171;BA.debugLine="If pi = Null Then Return";
if (_pi== nil) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=5767172;
 //BA.debugLineNum = 5767172;BA.debugLine="If Not(xui.IsB4i) Then";
if ((!([__ref->__xui /*B4IXUI**/  IsB4i]))) { 
B4IRDebugUtils.currentLine=5767173;
 //BA.debugLineNum = 5767173;BA.debugLine="If IsForeground Then";
if (__ref->__isforeground /*BOOL*/ ) { 
B4IRDebugUtils.currentLine=5767174;
 //BA.debugLineNum = 5767174;BA.debugLine="RaiseEventWithResult(pi, \"B4XPage_Disappear\", N";
[__ref _raiseeventwithresult /*NSObject**/ :nil :_pi :@"B4XPage_Disappear" :(B4IArray*)(nil)];
 };
 };
B4IRDebugUtils.currentLine=5767177;
 //BA.debugLineNum = 5767177;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _showpageimpl:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _pi{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"showpageimpl"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"showpageimpl:" :@[[B4I nilToNSNull:_pi]]]);}
B4IRDebugUtils.currentLine=6029312;
 //BA.debugLineNum = 6029312;BA.debugLine="Private Sub ShowPageImpl (pi As B4XPageInfo)";
B4IRDebugUtils.currentLine=6029327;
 //BA.debugLineNum = 6029327;BA.debugLine="mMainForm.ShowPage2(pi.Parent.NativeType, Transit";
[__ref->__mmainform /*B4INavigationControllerWrapper**/  ShowPage2:(UIViewController*)((_pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/ ).object) :__ref->__transitionanimationduration /*int*/ >0];
B4IRDebugUtils.currentLine=6029329;
 //BA.debugLineNum = 6029329;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _toppageappear:(b4i_b4xpagesmanager*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"toppageappear"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"toppageappear" :nil]);}
_b4xpageinfo* _pi = nil;
B4IRDebugUtils.currentLine=5832704;
 //BA.debugLineNum = 5832704;BA.debugLine="Private Sub TopPageAppear";
B4IRDebugUtils.currentLine=5832705;
 //BA.debugLineNum = 5832705;BA.debugLine="Dim pi As B4XPageInfo = GetTopPage";
_pi = [__ref _gettoppage /*_b4xpageinfo**/ :nil];
B4IRDebugUtils.currentLine=5832706;
 //BA.debugLineNum = 5832706;BA.debugLine="If pi = Null Then Return";
if (_pi== nil) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=5832707;
 //BA.debugLineNum = 5832707;BA.debugLine="pi.Parent.NativeType.Title = pi.Title";
[_pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/  setTitle:[self.bi ObjectToString:_pi->_Title /*NSObject**/ ]];
B4IRDebugUtils.currentLine=5832708;
 //BA.debugLineNum = 5832708;BA.debugLine="If Not(xui.IsB4i) Then";
if ((!([__ref->__xui /*B4IXUI**/  IsB4i]))) { 
B4IRDebugUtils.currentLine=5832709;
 //BA.debugLineNum = 5832709;BA.debugLine="If IsForeground Then";
if (__ref->__isforeground /*BOOL*/ ) { 
B4IRDebugUtils.currentLine=5832710;
 //BA.debugLineNum = 5832710;BA.debugLine="RaiseEvent(pi, \"B4XPage_Appear\", Null)";
[__ref _raiseevent /*NSString**/ :nil :_pi :@"B4XPage_Appear" :(B4IArray*)(nil)];
 };
 };
B4IRDebugUtils.currentLine=5832719;
 //BA.debugLineNum = 5832719;BA.debugLine="UpdateStackString";
[__ref _updatestackstring /*NSString**/ :nil];
B4IRDebugUtils.currentLine=5832720;
 //BA.debugLineNum = 5832720;BA.debugLine="End Sub";
return @"";
}
- (_b4xpageparent*)  _createb4xpageparent:(b4i_b4xpagesmanager*) __ref :(B4IPage*) _nativetype{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"createb4xpageparent"])
	 {return ((_b4xpageparent*) [B4IDebug delegate:self.bi :@"createb4xpageparent:" :@[[B4I nilToNSNull:_nativetype]]]);}
_b4xpageparent* _t1 = nil;
B4IRDebugUtils.currentLine=6815744;
 //BA.debugLineNum = 6815744;BA.debugLine="Private Sub CreateB4XPageParent (NativeType As Pag";
B4IRDebugUtils.currentLine=6815746;
 //BA.debugLineNum = 6815746;BA.debugLine="Dim t1 As B4XPageParent";
_t1 = [_b4xpageparent new];
B4IRDebugUtils.currentLine=6815747;
 //BA.debugLineNum = 6815747;BA.debugLine="t1.Initialize";
[_t1 Initialize];
B4IRDebugUtils.currentLine=6815748;
 //BA.debugLineNum = 6815748;BA.debugLine="t1.NativeType = NativeType";
_t1->_NativeType /*B4IPage**/  = _nativetype;
B4IRDebugUtils.currentLine=6815749;
 //BA.debugLineNum = 6815749;BA.debugLine="Return t1";
if (true) return _t1;
B4IRDebugUtils.currentLine=6815750;
 //BA.debugLineNum = 6815750;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _createpageimpl:(b4i_b4xpagesmanager*) __ref :(_b4xpageinfo*) _pi{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xpagesmanager";
if ([B4IDebug shouldDelegate: @"createpageimpl"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"createpageimpl:" :@[[B4I nilToNSNull:_pi]]]);}
B4IPage* _page = nil;
B4IRDebugUtils.currentLine=6225920;
 //BA.debugLineNum = 6225920;BA.debugLine="Private Sub CreatePageImpl (pi As B4XPageInfo)";
B4IRDebugUtils.currentLine=6225937;
 //BA.debugLineNum = 6225937;BA.debugLine="Dim page As Page";
_page = [B4IPage new];
B4IRDebugUtils.currentLine=6225938;
 //BA.debugLineNum = 6225938;BA.debugLine="page.Initialize(\"B4iPage\")";
[_page Initialize:self.bi :@"B4iPage"];
B4IRDebugUtils.currentLine=6225939;
 //BA.debugLineNum = 6225939;BA.debugLine="pi.Parent = CreateB4XPageParent(page)";
_pi->_Parent /*_b4xpageparent**/  = [__ref _createb4xpageparent /*_b4xpageparent**/ :nil :_page];
B4IRDebugUtils.currentLine=6225940;
 //BA.debugLineNum = 6225940;BA.debugLine="pi.Root = pi.Parent.NativeType.RootPanel";
_pi->_Root /*B4XViewWrapper**/  = (B4XViewWrapper*) [B4IObjectWrapper createWrapper:[B4XViewWrapper new] object:(NSObject*)(([_pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/  RootPanel]).object)];
B4IRDebugUtils.currentLine=6225941;
 //BA.debugLineNum = 6225941;BA.debugLine="pi.Parent.NativeType.Title = pi.Title";
[_pi->_Parent /*_b4xpageparent**/ ->_NativeType /*B4IPage**/  setTitle:[self.bi ObjectToString:_pi->_Title /*NSObject**/ ]];
B4IRDebugUtils.currentLine=6225943;
 //BA.debugLineNum = 6225943;BA.debugLine="End Sub";
return @"";
}
@end