
#import "b4i_b4xorderedmap.h"
#import "b4i_main.h"
#import "b4i_b4xmainpage.h"
#import "b4i_b4xpages.h"
#import "b4i_b4xbitset.h"
#import "b4i_b4xbytesbuilder.h"
#import "b4i_b4xcollections.h"
#import "b4i_b4xset.h"
#import "b4i_b4xpagesdelegator.h"
#import "b4i_b4xpagesmanager.h"


@implementation b4i_b4xorderedmap 


+ (B4I*)createBI {
    return [B4IShellBI alloc];
}

- (void)dealloc {
    if (self.bi != nil)
        NSLog(@"Class (b4i_b4xorderedmap) instance released.");
}

- (NSString*)  _initialize:(b4i_b4xorderedmap*) __ref :(B4I*) _ba{
__ref = self;
[self initializeClassModule];
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"initialize"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"initialize:" :@[[B4I nilToNSNull:_ba]]]);}
B4IRDebugUtils.currentLine=3342336;
 //BA.debugLineNum = 3342336;BA.debugLine="Public Sub Initialize";
B4IRDebugUtils.currentLine=3342337;
 //BA.debugLineNum = 3342337;BA.debugLine="map.Initialize";
[__ref->__map /*B4IMap**/  Initialize];
B4IRDebugUtils.currentLine=3342338;
 //BA.debugLineNum = 3342338;BA.debugLine="list.Initialize";
[__ref->__list /*B4IList**/  Initialize];
B4IRDebugUtils.currentLine=3342339;
 //BA.debugLineNum = 3342339;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _put:(b4i_b4xorderedmap*) __ref :(NSObject*) _key :(NSObject*) _value{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"put"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"put::" :@[[B4I nilToNSNull:_key],[B4I nilToNSNull:_value]]]);}
B4IRDebugUtils.currentLine=3407872;
 //BA.debugLineNum = 3407872;BA.debugLine="Public Sub Put (Key As Object, Value As Object)";
B4IRDebugUtils.currentLine=3407873;
 //BA.debugLineNum = 3407873;BA.debugLine="If map.ContainsKey(Key) = False Then";
if ([__ref->__map /*B4IMap**/  ContainsKey:_key]==false) { 
B4IRDebugUtils.currentLine=3407874;
 //BA.debugLineNum = 3407874;BA.debugLine="list.Add(Key)";
[__ref->__list /*B4IList**/  Add:_key];
 };
B4IRDebugUtils.currentLine=3407876;
 //BA.debugLineNum = 3407876;BA.debugLine="map.Put(Key, Value)";
[__ref->__map /*B4IMap**/  Put:_key :_value];
B4IRDebugUtils.currentLine=3407877;
 //BA.debugLineNum = 3407877;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _class_globals:(b4i_b4xorderedmap*) __ref{
__ref = self;
self->__main=[b4i_main new];
self->__b4xpages=[b4i_b4xpages new];
self->__b4xcollections=[b4i_b4xcollections new];
B4IRDebugUtils.currentModule=@"b4xorderedmap";
B4IRDebugUtils.currentLine=3276800;
 //BA.debugLineNum = 3276800;BA.debugLine="Sub Class_Globals";
B4IRDebugUtils.currentLine=3276801;
 //BA.debugLineNum = 3276801;BA.debugLine="Private map As Map";
self->__map = [B4IMap new];
B4IRDebugUtils.currentLine=3276802;
 //BA.debugLineNum = 3276802;BA.debugLine="Private list As List";
self->__list = [B4IList new];
B4IRDebugUtils.currentLine=3276803;
 //BA.debugLineNum = 3276803;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _clear:(b4i_b4xorderedmap*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"clear"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"clear" :nil]);}
B4IRDebugUtils.currentLine=3538944;
 //BA.debugLineNum = 3538944;BA.debugLine="Public Sub Clear";
B4IRDebugUtils.currentLine=3538945;
 //BA.debugLineNum = 3538945;BA.debugLine="list.Clear";
[__ref->__list /*B4IList**/  Clear];
B4IRDebugUtils.currentLine=3538946;
 //BA.debugLineNum = 3538946;BA.debugLine="map.Clear";
[__ref->__map /*B4IMap**/  Clear];
B4IRDebugUtils.currentLine=3538947;
 //BA.debugLineNum = 3538947;BA.debugLine="End Sub";
return @"";
}
- (BOOL)  _containskey:(b4i_b4xorderedmap*) __ref :(NSObject*) _key{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"containskey"])
	 {return ((NSNumber*) [B4IDebug delegate:self.bi :@"containskey:" :@[[B4I nilToNSNull:_key]]]).boolValue;}
B4IRDebugUtils.currentLine=3801088;
 //BA.debugLineNum = 3801088;BA.debugLine="Public Sub ContainsKey (Key As Object) As Boolean";
B4IRDebugUtils.currentLine=3801089;
 //BA.debugLineNum = 3801089;BA.debugLine="Return map.ContainsKey(Key)";
if (true) return [__ref->__map /*B4IMap**/  ContainsKey:_key];
B4IRDebugUtils.currentLine=3801090;
 //BA.debugLineNum = 3801090;BA.debugLine="End Sub";
return false;
}
- (NSObject*)  _get:(b4i_b4xorderedmap*) __ref :(NSObject*) _key{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"get"])
	 {return ((NSObject*) [B4IDebug delegate:self.bi :@"get:" :@[[B4I nilToNSNull:_key]]]);}
B4IRDebugUtils.currentLine=3670016;
 //BA.debugLineNum = 3670016;BA.debugLine="Public Sub Get (Key As Object) As Object";
B4IRDebugUtils.currentLine=3670017;
 //BA.debugLineNum = 3670017;BA.debugLine="Return map.Get(Key)";
if (true) return [__ref->__map /*B4IMap**/  Get:_key];
B4IRDebugUtils.currentLine=3670018;
 //BA.debugLineNum = 3670018;BA.debugLine="End Sub";
return nil;
}
- (NSObject*)  _getdataforserializator:(b4i_b4xorderedmap*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"getdataforserializator"])
	 {return ((NSObject*) [B4IDebug delegate:self.bi :@"getdataforserializator" :nil]);}
B4IRDebugUtils.currentLine=3997696;
 //BA.debugLineNum = 3997696;BA.debugLine="Public Sub GetDataForSerializator As Object";
B4IRDebugUtils.currentLine=3997697;
 //BA.debugLineNum = 3997697;BA.debugLine="Return Array(map, list)";
if (true) return (NSObject*)([[B4IArray alloc]initObjectsWithData:@[[B4I nilToNSNull:(NSObject*)(__ref->__map /*B4IMap**/ )],[B4I nilToNSNull:(NSObject*)((__ref->__list /*B4IList**/ ).object)]]]);
B4IRDebugUtils.currentLine=3997698;
 //BA.debugLineNum = 3997698;BA.debugLine="End Sub";
return nil;
}
- (NSObject*)  _getdefault:(b4i_b4xorderedmap*) __ref :(NSObject*) _key :(NSObject*) _defaultvalue{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"getdefault"])
	 {return ((NSObject*) [B4IDebug delegate:self.bi :@"getdefault::" :@[[B4I nilToNSNull:_key],[B4I nilToNSNull:_defaultvalue]]]);}
B4IRDebugUtils.currentLine=3735552;
 //BA.debugLineNum = 3735552;BA.debugLine="Public Sub GetDefault (Key As Object, DefaultValue";
B4IRDebugUtils.currentLine=3735553;
 //BA.debugLineNum = 3735553;BA.debugLine="Return map.GetDefault(Key, DefaultValue)";
if (true) return [__ref->__map /*B4IMap**/  GetDefault:_key :_defaultvalue];
B4IRDebugUtils.currentLine=3735554;
 //BA.debugLineNum = 3735554;BA.debugLine="End Sub";
return nil;
}
- (B4IList*)  _getkeys:(b4i_b4xorderedmap*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"getkeys"])
	 {return ((B4IList*) [B4IDebug delegate:self.bi :@"getkeys" :nil]);}
B4IRDebugUtils.currentLine=3604480;
 //BA.debugLineNum = 3604480;BA.debugLine="Public Sub getKeys As List";
B4IRDebugUtils.currentLine=3604481;
 //BA.debugLineNum = 3604481;BA.debugLine="Return list";
if (true) return __ref->__list /*B4IList**/ ;
B4IRDebugUtils.currentLine=3604482;
 //BA.debugLineNum = 3604482;BA.debugLine="End Sub";
return nil;
}
- (int)  _getsize:(b4i_b4xorderedmap*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"getsize"])
	 {return ((NSNumber*) [B4IDebug delegate:self.bi :@"getsize" :nil]).intValue;}
B4IRDebugUtils.currentLine=3866624;
 //BA.debugLineNum = 3866624;BA.debugLine="Public Sub getSize As Int";
B4IRDebugUtils.currentLine=3866625;
 //BA.debugLineNum = 3866625;BA.debugLine="Return map.Size";
if (true) return [__ref->__map /*B4IMap**/  Size];
B4IRDebugUtils.currentLine=3866626;
 //BA.debugLineNum = 3866626;BA.debugLine="End Sub";
return 0;
}
- (B4IList*)  _getvalues:(b4i_b4xorderedmap*) __ref{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"getvalues"])
	 {return ((B4IList*) [B4IDebug delegate:self.bi :@"getvalues" :nil]);}
B4IList* _res = nil;
NSObject* _key = nil;
B4IRDebugUtils.currentLine=3932160;
 //BA.debugLineNum = 3932160;BA.debugLine="Public Sub getValues As List";
B4IRDebugUtils.currentLine=3932161;
 //BA.debugLineNum = 3932161;BA.debugLine="Dim res As List";
_res = [B4IList new];
B4IRDebugUtils.currentLine=3932162;
 //BA.debugLineNum = 3932162;BA.debugLine="res.Initialize";
[_res Initialize];
B4IRDebugUtils.currentLine=3932163;
 //BA.debugLineNum = 3932163;BA.debugLine="For Each key As Object In list";
{
const id<B4IIterable> group3 = __ref->__list /*B4IList**/ ;
const int groupLen3 = group3.Size
;int index3 = 0;
;
for (; index3 < groupLen3;index3++){
_key = [group3 Get:index3];
B4IRDebugUtils.currentLine=3932164;
 //BA.debugLineNum = 3932164;BA.debugLine="res.Add(map.Get(key))";
[_res Add:[__ref->__map /*B4IMap**/  Get:_key]];
 }
};
B4IRDebugUtils.currentLine=3932166;
 //BA.debugLineNum = 3932166;BA.debugLine="Return res";
if (true) return _res;
B4IRDebugUtils.currentLine=3932167;
 //BA.debugLineNum = 3932167;BA.debugLine="End Sub";
return nil;
}
- (NSString*)  _remove:(b4i_b4xorderedmap*) __ref :(NSObject*) _key{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"remove"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"remove:" :@[[B4I nilToNSNull:_key]]]);}
B4IRDebugUtils.currentLine=3473408;
 //BA.debugLineNum = 3473408;BA.debugLine="Public Sub Remove (Key As Object)";
B4IRDebugUtils.currentLine=3473409;
 //BA.debugLineNum = 3473409;BA.debugLine="If map.ContainsKey(Key) = False Then Return";
if ([__ref->__map /*B4IMap**/  ContainsKey:_key]==false) { 
if (true) return @"";};
B4IRDebugUtils.currentLine=3473410;
 //BA.debugLineNum = 3473410;BA.debugLine="list.RemoveAt(list.IndexOf(Key))";
[__ref->__list /*B4IList**/  RemoveAt:[__ref->__list /*B4IList**/  IndexOf:_key]];
B4IRDebugUtils.currentLine=3473411;
 //BA.debugLineNum = 3473411;BA.debugLine="map.Remove(Key)";
[__ref->__map /*B4IMap**/  Remove:_key];
B4IRDebugUtils.currentLine=3473412;
 //BA.debugLineNum = 3473412;BA.debugLine="End Sub";
return @"";
}
- (NSString*)  _setdatafromserializator:(b4i_b4xorderedmap*) __ref :(NSObject*) _data{
__ref = self;
B4IRDebugUtils.currentModule=@"b4xorderedmap";
if ([B4IDebug shouldDelegate: @"setdatafromserializator"])
	 {return ((NSString*) [B4IDebug delegate:self.bi :@"setdatafromserializator:" :@[[B4I nilToNSNull:_data]]]);}
B4IArray* _o = nil;
B4IRDebugUtils.currentLine=4063232;
 //BA.debugLineNum = 4063232;BA.debugLine="Public Sub SetDataFromSerializator (Data As Object";
B4IRDebugUtils.currentLine=4063233;
 //BA.debugLineNum = 4063233;BA.debugLine="Dim o() As Object = Data";
_o = (B4IArray*)(_data);
B4IRDebugUtils.currentLine=4063234;
 //BA.debugLineNum = 4063234;BA.debugLine="map = o(0)";
__ref->__map /*B4IMap**/  = (B4IMap*)(((NSObject*)[_o getObjectFast:(int) (0)]));
B4IRDebugUtils.currentLine=4063235;
 //BA.debugLineNum = 4063235;BA.debugLine="list = o(1)";
__ref->__list /*B4IList**/  = (B4IList*) [B4IObjectWrapper createWrapper:[B4IList new] object:(NSArray*)(((NSObject*)[_o getObjectFast:(int) (1)]))];
B4IRDebugUtils.currentLine=4063236;
 //BA.debugLineNum = 4063236;BA.debugLine="End Sub";
return @"";
}
@end